import time
import serial

class bcolors:
    HEADER = '\033[95m'
    OKBLUE = '\033[94m'
    OKCYAN = '\033[96m'
    OKGREEN = '\033[92m'
    WARNING = '\033[93m'
    FAIL = '\033[91m'
    ENDC = '\033[0m'
    BOLD = '\033[1m'
    UNDERLINE = '\033[4m'

lorem = b"Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut l"

readIndex = 0

ser = serial.Serial('/dev/ttyUSB0', 921600, timeout=0.050)
count = 0
count_read = 0
sum_count_write = 0
sum_count_read = 0
start = time.time()
while 1:
    ser.write(lorem)
    # print(f"{bcolors.OKBLUE}<<< {lorem}{bcolors.ENDC}")
    count += len(lorem)
    if time.time() - start >= 1:
        start += 1
        sum_count_write += count
        sum_count_read += count_read
        print(f"Sent: {count} tot: {sum_count_write}")
        print(f"Got: {count_read} tot: {sum_count_read}")
        count = 0
        count_read = 0
    
    if (ser.inWaiting() > 0):
        data_str = ser.read(ser.inWaiting())
        count_read += len(data_str)
        error = 0
        for i in range(len(data_str)):
            if lorem[readIndex] == data_str[i]:
                readIndex += 1
                if readIndex >= len(lorem):
                    readIndex = 0
                pass #ok
            else:
                error += 1
        # if error == 0:
        #     print(f"{bcolors.OKGREEN}>>> {data_str}{bcolors.ENDC}")
        # else:
        #     print(f"{bcolors.WARNING}>>> {data_str}{bcolors.ENDC}")

    time.sleep(0.01)